#/usr/bin/perl -w
<<DOC; 
Marie Garrigue
Sandy Bonin
MARS 2010

 commande : perl bao2.pl repertoire_a_parcourir

 Le programme prend en entre le nom du rpertoire contenant les fichiers
  traiter
 Le programme construit en sortie un fichier structur contenant sur chaque
 ligne le nom du fichier et le rsultat du filtrage
DOC
#-----------------------------------------------------------------------------------------------
#On appelle des modules
use XML::RSS;
use HTML::Entities;
#-----------------------------------------------------------------------------------------------
#On rcupre, dans une variable "$rep", le nom du rpertoire qui a t pass en paramtre au programme
my $rep="$ARGV[0]";
#On normalise l'criture du nom du rpertoire afin de s'assurer qu'il ne se termine pas par un "/"
$rep=~s/[\/]$//;
#On initialise une variable "$DUMPFULL1" qui va contenir le flux de sortie 1
my $DUMPFULL1="";
#On initialise une variable "$DUMPFULL2" qui va contenir le flux de sortie 2
my $DUMPFULL2="";
#-----------------------------------------------------------------------------------------------
#On ouvre en criture le fichier de sortie 1
my $output1="resultat_bao1.txt";
if (!open (FILEOUT1,">$output1")) {die "Probleme lors de l'ouverture du fichier $output1"};
#On ouvre en criture le fichier de sortie 2
my $output2="resultat_bao1.xml";
if (!open (FILEOUT2,">$output2")) {die "Probleme lors de l'ouverture du fichier $output2"};
#-----------------------------------------------------------------------------------------------
#On lance le parcours rcursif via la procdure "parcoursarborescence" qui prend comme argument la variable "$rep"
#Il va parcourir le rpertoire dont le nom a t pass en paramtre au programme
&parcoursarborescence($rep);	#Rcursivit
#-----------------------------------------------------------------------------------------------
#On formate le fichier de sortie 1 : On intgre le contenu de la variable "$DUMPFULL1"
print FILEOUT1 $DUMPFULL1;
#On ferme le fichier de sortie 1
close(FILEOUT1);
#On formate le fichier de sortie 2 : On crit l'en-tte du fichier xml et on intgre, entre une balise ouvrante "<rss>" et sa balise fermante, le contenu de la variable "$DUMPFULL2"
print FILEOUT2 "<?xml version=\"1.0\" encoding=\"iso-8859-1\" ?>\n";
print FILEOUT2 "<xml>\n";
print FILEOUT2 "<rss>".$DUMPFULL2."</rss>\n";
print FILEOUT2 "</xml>\n";
#On ferme le fichier de sortie 2
close(FILEOUT2);
#On lance la procdure "etiquetage" qui prend comme argument la variable "$DUMPFULL1"
&etiquetage($DUMPFULL1);
#On sort du programme
exit;
#-----------------------------------------------------------------------------------------------
#PROCEDURES
#-----------------------------------------------------------------------------------------------
#On cre la procdure "parcoursarborescence"
sub parcoursarborescence {
	#On utilise la variable prdfinie "@_" (Aussi appele Tableau spcial) afin de rcuprer les arguments (Ici le nom du rpertoire) passs en paramtre  la procdure
	my $path=shift(@_);
	#On ouvre le rpertoire
	opendir(DIR,$path) or die "Probleme lors de l'ouverture de $path: $!\n";
	#On rcupre le contenu du rpertoire
	my @contenurep=readdir(DIR);
	#On ferme le rpertoire
	closedir(DIR);
	#Pour chaque lment contenu dans le rpertoire, on vrifie son type (Fichier ou Rpertoire) 
	foreach my $element(@contenurep) {
		#On passe au suivant si l'lment contient un point ou deux points
		next if $element=~/^\.\.?$/;
		#On affecte  la variable "$element" le chemin complet de l'lment
		$element=$path."/".$element;
		#Si l'lment est un rpertoire, on effectue les oprations suivantes
		if (-d $element) {
			#On relance le parcours via la procdure "parcoursarborescence" qui prend comme argument la variable "$element"
			&parcoursarborescence($element);	#Rcursivit
		}
		#Si l'lment est un fichier, on effectue les oprations suivantes
		if (-f $element) {
			#On lance la procdure "filtrage" qui prend comme argument la variable "$element"
			&filtrage($element);
		}
	}
}
#-----------------------------------------------------------------------------------------------
#On cre la procdure "filtrage"
sub filtrage {
	#On affecte  la variable "$element" le contenu de la variable passe en paramtre  la procdure
	my $element=shift;
	#Si le fichier fait parti de la rubrique "International", on effectue les oprations suivantes
	if ($element=~/0,2-3210,1-0,0.xml/) {
		#On cre une variable "$rss"
		my $rss=new XML::RSS;
		#On cre une variable vide "$TEXTEDUFIL"
		my $TEXTEDUFIL="";
		#On ajoute  la suite du contenu de la variable "$TEXTEDUFIL" une balise ouvrante "<file>" qui a un attribut "id" dont la valeur est le contenu de la variable "$element"
		$TEXTEDUFIL.="<file id=\"$element\">\n";
		#On met les articles contenus dans le fichier dans la variable "$rss"
		$rss->parsefile($element);
		#On cre un compteur "$nombrearticles" qui va contenir le nombre d'articles prsents dans le fichier et on l'initialise  0
		my $nombrearticles=0;
		#Pour chaque article dans la variable "$rss", on effectue les oprations suivantes
		foreach my $item (@{$rss->{'items'}}) {
			#On met le contenu de la balise "<title>" de l'article dans une variable "$title"
			my $title=$item->{'title'};
			#On lance la procdure "nettoyage" qui prend comme argument la variable "$title"
			$title=&nettoyage($title);
			#Si la table de hachage "$dicoarticles" contient dj la cl contenue dans la variable "$title" et si la variable "$title" n'est pas vide, on effectue les oprations suivantes
			if ((!(exists($dicoarticles{$title})))&&($title ne "")) {
				#On incrmente le compteur "$nombrearticles"
				$nombrearticles++;
				#On ajoute  la suite du contenu de la variable "$TEXTEDUFIL" une balise ouvrante "<article>" qui a un attribut "id" dont la valeur est le numro de l'article
				$TEXTEDUFIL.="<article id=\"$nombrearticles\">\n";
				#On ajoute  la suite de la variable "$TEXTEDUFIL" la balise ouvrante "<title>", le contenu de la variable "$title" et la balise fermante "</title>"
				$TEXTEDUFIL.="<title>".$title."</title>\n";
				#On ajoute  la suite de la variable "$DUMPFULL1" le contenu de la variable "$title"
				$DUMPFULL1.=$title."\n";
				#On met le contenu de la balise "description" dans une variable "$description"
				my $description=$item->{'description'};
				#On lance la procdure "nettoyage" qui prend comme argument la variable "$description"
				$description=&nettoyage($description);
				#On ajoute  la suite de la variable "$TEXTEDUFIL" la balise ouvrante "<description>", le contenu de la variable "$description", la balise fermante "</description>" et la balise fermante "</article>"
				$TEXTEDUFIL.="<description>".$description."</description>\n</article>\n";
				#On ajoute  la suite de la variable "$DUMPFULL1" le contenu de la variable "$description"
				$DUMPFULL1.=$description."\n";
				#On ajoute  la table de hachage "$dicoarticles" la cl "$title" qui a pour valeur "1"
				$dicoarticles{$title}=1;
			}
			#Sinon, on effectue les oprations suivantes
			else {
				#On incrmente la valeur de la cl "$title" contenu dans la table de hachage "$dicoarticles"
				$dicoarticles{$title}++;
			}
		}
		#On ajoute  la suite de la variable "$DUMPFULL2" le contenu de la variable "$TEXTEDUFIL" et la balise fermante "</file>"
		$DUMPFULL2.=$TEXTEDUFIL."</file>\n";
	}
}
#-----------------------------------------------------------------------------------------------
#On cre la procdure "nettoyage"
sub nettoyage {
	#On affecte  une variable "$nett" le contenu de la variable passe en paramtre  la procdure
	my $nett=shift;
	#On utilise le module HTML::Entities afin de dcoder les entits html
	$nett=HTML::Entities::decode($nett);
	#On remplace le caractre "&" par la chane de caractres "and"
	$nett=~s/&/ and /g;
	#On supprime les balises html
	$nett=~s/<(.+)>//g;
	#On remplace les espaces qui se suivent par un seul espace
	$nett=~s/[ ]+/ /g;
	#Si le contenu de la variable "$nett" se termine par un caractre alphanumrique ou par des guillemets, on effectue les oprations suivantes
	if ($nett=~/[[:alnum:]"]$/) {
		#On ajoute un point  la fin du contenu de la variable "$nett"
		$nett.=".";
	}
	#On remplace la chane de caractres "Retrouvez l'ensemble des dpches sur http://www.lemonde.fr" par rien
	if ($nett eq "Retrouvez l'ensemble des dpches sur http://www.lemonde.fr") {$nett=""};
	#On retourne le contenu de la variable "$nett"
	return $nett;
}
#-----------------------------------------------------------------------------------------------
#On cre la procdure "etiquetage"
sub etiquetage {
	#On affecte  une variable "$DUMPFULL3" le contenu de la variable passe en paramtre  la procdure
	my $DUMPFULL3=shift;
	#On ouvre un fichier temporaire
	my $tmp="tmp.txt";
	if (!open (FILETMP,">$tmp")) {die "Probleme lors de l'ouverture du fichier $tmp"};
	#On copie le contenu de la variable "$DUMPFULL3" dans le fichier temporaire
	print FILETMP $DUMPFULL3;
	#On ferme le fichier temporaire
	close(FILETMP);
	#On procde  l'tiquetage avec TreeTagger
	#"system" permet de lancer un programme externe au programme
	system("perl ./treetagger/cmd/tokenise-fr.pl tmp.txt | ./treetagger/bin/tree-tagger ./treetagger/lib/french.par -token -lemma -sgml -no-unknown > resultat_bao2_treetagger.txt");
	#On transforme le fichier de rsultat en un fichier xml temporaire
	system("perl ./treetagger/treetagger2xml.pl resultat_bao2_treetagger.txt");
	#On concatne le contenu des fichiers tiquets dans un fichier xml
	system("cat resultat_bao2_treetagger.txt.xml >> resultat_bao2_treetagger.xml");
	#On supprime les fichiers temporaires
	unlink("tmp.txt");
	unlink("resultat_bao2_treetagger.txt.xml");
}
